#include "MQPlugin.h"
#include "MQBasePlugin.h"

#include <unordered_map>

class ObjectViewSwitcher : public MQStationPlugin
{
public:
	friend ObjectViewSwitcherWindow;

	ObjectViewSwitcher();
	virtual ~ObjectViewSwitcher();

	// vOCIDԂB
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// vOCԂB
	virtual const char *GetPlugInName(void);
	// |bvAbvj[ɕ\镶ԂB
	virtual const char *EnumString(void);

	// AvP[V̏
	virtual BOOL Initialize();
	// AvP[V̏I
	virtual void Exit();

	// \E\؂ւv
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// \E\Ԃ̕ԓ
	virtual BOOL IsActivated(MQDocument doc);

	virtual void OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param);
	virtual void OnSaveDocument(MQDocument doc, const char *filename, SAVE_DOCUMENT_PARAM& param);

	typedef bool (ObjectViewSwitcher::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

	BOOL set_list(MQDocument doc, int index, bool selectedonly = false);
	BOOL restore_list(MQDocument doc, int index);
	BOOL clear_list(MQDocument doc, int index);
	size_t stragesize() const {return m_storagesize;}
	bool hasdata(int index) const;
	BOOL addSlot();

protected:
	struct CallbackInfo {
		ExecuteCallbackProc proc;
	};

	// R[obNɑ΂
	virtual bool ExecuteCallback(MQDocument doc, void *option);

private:
	ObjectViewSwitcherWindow *m_Window;

	bool m_bActivate;
	size_t m_storagesize;
	size_t m_newstoragesize;
	std::vector<std::unordered_map<std::string, bool>> m_viewlist;
};

